package com.github.polpetta.mezzotre.orm;

import com.github.polpetta.mezzotre.orm.model.query.QCallbackQueryContext;
import io.ebean.typequery.PString;
import java.util.concurrent.CompletableFuture;
import java.util.function.Supplier;
import javax.inject.Inject;
import javax.inject.Singleton;
import org.slf4j.Logger;

// FIXME tests, doc
@Singleton
public class CallbackQueryContextCleaner {

  private static final Supplier<PString<QCallbackQueryContext>> ENTRY_GROUP =
      () -> new QCallbackQueryContext().entryGroup;
  private static final Supplier<PString<QCallbackQueryContext>> SINGLE_ENTRY =
      () -> new QCallbackQueryContext().id;

  private final BatchBeanCleanerService batchBeanCleanerService;
  private final Logger log;

  @Inject
  public CallbackQueryContextCleaner(BatchBeanCleanerService batchBeanCleanerService, Logger log) {
    this.batchBeanCleanerService = batchBeanCleanerService;
    this.log = log;
  }

  public CompletableFuture<Integer> removeGroupAsync(String id) {
    log.trace("CallbackQueryContext entry group " + id + " queued for removal");
    return batchBeanCleanerService.removeAsync(id, ENTRY_GROUP.get());
  }

  public CompletableFuture<Integer> removeIdAsync(String id) {
    log.trace("CallbackQueryContext single entity " + id + " queued for removal");
    return batchBeanCleanerService.removeAsync(id, SINGLE_ENTRY.get());
  }
}
