package com.github.polpetta.mezzotre.orm.model;

import io.ebean.Model;
import io.ebean.annotation.WhenCreated;
import io.ebean.annotation.WhenModified;
import java.time.Instant;
import javax.persistence.MappedSuperclass;

/**
 * Father class to all the database objects. It allows to add when an object has been created and
 * modifies
 *
 * @author Davide Polonio
 * @since 1.0-SNAPSHOT
 */
@MappedSuperclass
public class Base extends Model {

  @WhenCreated private Instant entryCreated;

  @WhenModified private Instant entryModified;

  public Instant getEntryModified() {
    return entryModified;
  }

  public Instant getEntryCreated() {
    return entryCreated;
  }
}
