package com.github.polpetta.mezzotre.orm.model;

import io.ebean.annotation.ConstraintMode;
import io.ebean.annotation.DbForeignKey;
import io.ebean.annotation.Length;
import io.ebean.annotation.NotNull;
import javax.annotation.Nullable;
import javax.persistence.*;

@Entity
@Table(name = "registered_user")
public class User extends Base {

  @Id
  @Length(64)
  private final String id;

  @Column(columnDefinition = "boolean default false")
  @NotNull
  private Boolean isActive;

  @OneToOne(fetch = FetchType.LAZY, optional = true)
  @DbForeignKey(onDelete = ConstraintMode.CASCADE)
  @JoinColumn(name = "telegram_id", referencedColumnName = "id")
  private TgChat telegramId;

  @Length(256)
  @Nullable
  private String emailAddress;

  public User(String id, String emailAddress, Boolean isActive, TgChat telegramId) {
    this.id = id;
    this.emailAddress = emailAddress;
    this.isActive = isActive;
    this.telegramId = telegramId;
  }

  public String getId() {
    return id;
  }

  public Boolean isActive() {
    return isActive;
  }

  public void setActive(Boolean active) {
    isActive = active;
  }

  public TgChat getTelegramId() {
    return telegramId;
  }

  public void setTelegramId(TgChat telegramId) {
    this.telegramId = telegramId;
  }

  public String getEmailAddress() {
    return emailAddress;
  }

  public void setEmailAddress(String emailAddress) {
    this.emailAddress = emailAddress;
  }
}
