package com.github.polpetta.mezzotre.telegram.callbackquery;

import com.google.inject.AbstractModule;
import com.google.inject.Provides;
import com.google.inject.assistedinject.FactoryModuleBuilder;
import java.util.HashMap;
import java.util.Map;
import javax.inject.Named;
import javax.inject.Singleton;

public class CallbackQueryDI extends AbstractModule {

  @Override
  protected void configure() {
    super.configure();

    install(
        new FactoryModuleBuilder()
            .implement(Processor.class, NotFound.class)
            .build(NotFoundFactory.class));
  }

  @Provides
  @Singleton
  @Named("eventProcessors")
  public Map<String, Processor> getEventProcessor(
      SelectLanguageTutorial selectLanguageTutorial, ShowHelp showHelp) {
    final HashMap<String, Processor> commandMap = new HashMap<>();
    commandMap.put(selectLanguageTutorial.getEventName(), selectLanguageTutorial);
    commandMap.put(showHelp.getEventName(), showHelp);
    return commandMap;
  }
}
