package com.github.polpetta.mezzotre.telegram.callbackquery;

import com.pengrad.telegrambot.model.Message;
import com.pengrad.telegrambot.model.Update;
import java.util.Optional;

/**
 * A class with misc utilities
 *
 * @author Davide Polonio
 * @since 1.0
 */
public class Util {

  /**
   * Extract the message id of the given {@link Update}
   *
   * @param update the {@link Update} to check and search the message id for
   * @return an {@link Optional} containing a {@link Integer} with the message id if it is present,
   *     otherwise a {@link Optional#empty()} if it is not found.
   */
  public static Optional<Integer> extractMessageId(Update update) {
    return Optional.ofNullable(update.callbackQuery().message()).map(Message::messageId);
  }
}
