package com.github.polpetta.mezzotre.util;

import com.google.common.util.concurrent.Service;
import com.google.inject.AbstractModule;
import com.google.inject.Provides;
import java.util.List;
import java.util.concurrent.Executor;
import java.util.concurrent.Executors;
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.TimeUnit;
import javax.inject.Named;
import javax.inject.Singleton;
import org.apache.commons.lang3.tuple.Pair;

public class UtilDI extends AbstractModule {
  @Provides
  @Singleton
  @Named("eventThreadPool")
  public Executor getEventExecutor() {
    return ForkJoinPool.commonPool();
  }

  @Provides
  @Singleton
  @Named("longJobThreadPool")
  public Executor getLongJobExecutor() {
    return Executors.newCachedThreadPool();
  }

  @Provides
  @Singleton
  @Named("serviceModule")
  public ServiceModule getServiceModule(@Named("services") List<Service> moduleList) {
    return new ServiceModule(moduleList);
  }

  @Provides
  @Singleton
  @Named("serviceRunningCheckTime")
  public Pair<Integer, TimeUnit> getTime() {
    return Pair.of(5, TimeUnit.SECONDS);
  }
}
