-- apply changes
create table callback_query_context (
                                        id                            varchar(36) not null,
                                        entry_group                   varchar(36) not null,
                                        fields                        json not null default '{}'::json not null,
                                        entry_created                 timestamptz not null,
                                        entry_modified                timestamptz not null,
                                        constraint pk_callback_query_context primary key (id)
);

create table telegram_chat (
                               id                            bigint generated by default as identity not null,
                               chat_context                  jsonb not null default '{}'::jsonb not null,
                               locale                        varchar(5) not null default 'en-US' not null,
                               has_help_been_shown           boolean default false not null,
                               entry_created                 timestamptz not null,
                               entry_modified                timestamptz not null,
                               constraint pk_telegram_chat primary key (id)
);

create table registered_user (
                                 id                            varchar(64) not null,
                                 is_active                     boolean default false not null,
                                 telegram_id                   bigint,
                                 email_address                 varchar(256),
                                 entry_created                 timestamptz not null,
                                 entry_modified                timestamptz not null,
                                 constraint uq_registered_user_telegram_id unique (telegram_id),
                                 constraint pk_registered_user primary key (id)
);

-- foreign keys and indices
alter table registered_user add constraint fk_registered_user_telegram_id foreign key (telegram_id) references telegram_chat (id) on delete cascade on update restrict;
