package com.github.polpetta.mezzotre.telegram.model;

import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

import com.github.polpetta.mezzotre.i18n.TemplateContentGenerator;
import com.github.polpetta.mezzotre.orm.model.TgChat;
import com.github.polpetta.mezzotre.util.UUIDGenerator;
import java.util.Collections;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.parallel.Execution;
import org.junit.jupiter.api.parallel.ExecutionMode;

@Execution(ExecutionMode.CONCURRENT)
class HelpTest {

  private TemplateContentGenerator fakeTemplateContentGenerator;
  private UUIDGenerator fakeUUIDGenerator;
  private Help help;

  @BeforeEach
  void setUp() {

    fakeTemplateContentGenerator = mock(TemplateContentGenerator.class);
    fakeUUIDGenerator = mock(UUIDGenerator.class);

    help = new Help(fakeTemplateContentGenerator, fakeUUIDGenerator);
  }

  @Test
  void shouldCallTemplateContentGeneratorRight() {

    final TgChat fakeChat = mock(TgChat.class);
    when(fakeChat.getLocale()).thenReturn("en-US");

    final String message = help.getMessage(fakeChat, Collections.emptyMap());

    verify(fakeTemplateContentGenerator, times(1))
        .mergeTemplate(any(), eq("en-US"), eq("template/telegram/help.vm"));
  }
}
